/***************************************************************************
*   Copyright (C) 2004 by david                                           *
*   david@pimp.centrium.all                                               *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#ifndef _K2SENDPREF_H_
#define _K2SENDPREF_H_

#include <kdialogbase.h>
#include <kdebug.h>
#include <kglobal.h>
#include <kiconloader.h>
#include <kpixmap.h>
#include <qframe.h>
#include <qgrid.h>
#include <qvariant.h>
#include <qwidget.h>
#include <qlistbox.h>
#include <qthread.h>

class KBtscoPrefPagePlayer;
class KListBox;
class KPushButton;
class KLineEdit;
class ScanThread;
class KConfig;
class K2sendWidget;
class QComboBox;
class QListBox;
class QCheckBox;
class QComboBox;

class KBtscoPreferences: public KDialogBase
{
Q_OBJECT public:
    KBtscoPreferences (KConfig * c);
    void customEvent (QCustomEvent * e);

private:
    KBtscoPrefPagePlayer * m_pagePlayer;
    KListBox    *m_list_device;
    KPushButton *m_button_scan;
    KLineEdit   *m_edit_name;
    QComboBox   *m_edit_channel;
    QLabel      *m_scan_label;
    QLabel      *m_hci_label;
    ScanThread  *m_scan_thread;
    KConfig     *m_config;
    QComboBox   *m_combo_box1;
    QCheckBox   *m_check_osd;
    QListBox    *m_list_box1;

private slots:
    virtual void slotScan ();
    virtual void slotApply ();
    virtual void slotOk ();
    void slotDeviceSelected ();

};


class AddressItem: public QListBoxPixmap
{
public:
    AddressItem ( const QString & ba ,const QString & n)
    : QListBoxPixmap (KGlobal::iconLoader()->loadIcon( "connect_no", KIcon::Small, 16))
    , m_baddr (ba)
    , m_name(n)
    {
        if (!m_name.isEmpty()){
            QString label = m_name + " [" + m_baddr + "]";
            this->setText(label);
        }else{
            this->setText(m_baddr);
        }
    }
    QString  addr () const
    {
        return m_baddr;
    }
    QString  name () const
    {
        return m_name;
    }
    private:
        QString m_baddr;
        QString m_name;
};


class ScanThread: public QThread
{
public:
    ScanThread (QWidget * p): m_parent (p)
    {}
    ~ScanThread ();
    virtual void run ();
private:
    QWidget * m_parent;
};


class ScanThreadEvent: public QCustomEvent
{
public:
    ScanThreadEvent (int type, QString string1 = NULL, QString string2 = NULL,QString string3 = NULL)
    : QCustomEvent (type), s1 (string1), s2 (string2) ,  s3 (string3)
    {}

    QString string1 () const
    {
        return s1;
    }
    QString string2 () const
    {
        return s2;
    }
    QString string3 () const
    {
        return s3;
    }
    typedef enum Type
    { Error = 66000,
      BAddr,
      Message,
      Clear,
      HCIAddr,
    }
    Type;
private:
    QString s1;
    QString s2;
    QString s3;
};

#endif // _K2SENDPREF_H_
